.386                                             
.MODEL FLAT,STDCALL
include kTEAR.Inc


.DATA
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;	                           Interface
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


hinst_       dd          0

fileName db 'crypto.key',0


.DATA?

NameBuffer dd 16h dup (?)

resultMD5 dd 4 dup (?)
bufferMD5 db 80h dup  (?)
CRCBuffer db 16h dup (?)
nbWritten dd ?

Serialp1 dw 13 dup (?)
Serialp2 dd  2 dup (?)
RC6_S dd 0B0h dup (?)

buf1		dd ?			
buf2		dd ?			
buf3		dd ?			
buf4		dd ?			
buf5		dd 4 dup(?)		
buf6		dd ?			
buf7		db ?	

.CODE
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;	                        Debut du Code
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Corps:
	call	GetModuleHandleA,0
	test	eax,eax
	jne		gmhok	
	call	ExitProcess,0
	
gmhok:  
	mov		hinst_, eax
	call	DialogBoxParamA, hinst_, DLG_MAIN, 0, offset DlgProcedure, 0
	call	ExitProcess,0

;***********************************************************************
PUBLIC DlgProcedure
DlgProcedure PROC STDCALL,hwnd_:DWORD,wmsg:DWORD,wparam_:DWORD,lparam_:DWORD
	USES ebx, edi, esi

	cmp	    wmsg, WM_DESTROY
	je	    wmdestroy
	cmp	    wmsg, WM_CLOSE
	je	    wmdestroy
	cmp	    wmsg, WM_COMMAND	
	je	    wmcommand
	xor	    eax, eax
	RET
	
wmdestroy:
	call	EndDialog, hwnd_, 0
	call	ExitProcess,0

wmcommand:
	cmp     word ptr [wparam_], BTN_EXIT 
	je   	wmdestroy
	cmp     word ptr [wparam_], BTN_SERIAL
	je   	wmSerial
	RET
	
	
wmSerial:
    call    Generateur
	RET



DlgProcedure ENDP

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;            Generateur de clef
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Generateur proc
	pusha

	; Wipe Buffer
	xor eax, eax
	mov ecx, 16h
	mov edi, offset CRCBuffer
	cld
	rep stosb 
	
	xor eax, eax
	mov ecx, 0B0h
	mov edi, offset RC6_S
	cld
	rep stosd 	
	
	call GetDlgItemTextA, hwnd_, CHAMPS_SERIAL, offset NameBuffer, 15
	cmp eax, 0
	jz errorName
	cmp eax, 15	
	ja errorName
	
	mov ecx, eax
	mov esi, offset NameBuffer
	mov edi, offset CRCBuffer
	cld
	rep movsb
	
	mov ecx, 16
	mov esi, offset CRCBuffer
	mov edi, offset Serialp1
	cld
	rep movsb



; :::::::::::::::::::::::::::::    Forge CRC   :::::::::::::::::::::::::::::

	mov edx, offset CRCBuffer
	mov ecx, 14h
	xor eax, eax
	call CRC_16
	xor [edx], ax
	
	mov edx, offset CRCBuffer
	mov ecx, 16h
	xor eax, eax
	call CRC_32
	push edx
	
forge_crc:
	not eax
	xor ebx, ebx
	mov ecx, 32
	inv_crc_1:
		rcr  eax, 1
		rcl  ebx,1
	loop inv_crc_1
	
	mov eax, 0FFFFFFFFh
	xor eax, ebx
	
	call rev_CRC_32
	
		
	;mult_CRC
	mov esi, 8803h
	mov edi, 587BD12h            ; esi:edi

	
	xor ebx, ebx
	xor edx, edx
	xor ecx, ecx	
loop_mul_CRC:	

    test ebx, 10000h
	jz not_mod_crc
	xor ebx, 186A4h         ; ebx:eax
	xor eax, 84A9EB6Bh	
		
not_mod_crc:	
	test edi, 1
	jz mul_CRC
	xor ecx, eax         ; edx:ecx
	xor edx, ebx

mul_CRC:
    shr esi, 1
	rcr edi, 1
	shl eax, 1
	rcl ebx, 1
	
	cmp edi, 0
	jnz loop_mul_CRC
	cmp esi, 0
	jnz loop_mul_CRC
	
	mov eax, ecx
	mov ebx, edx
	
	xor edx, edx
	mov ecx, 32
	inv_crc_2:
		rcr  eax, 1
		rcl  edx,1
	loop inv_crc_2
	
	pop eax
	xor [eax-4], edx

	xor edx, edx
	mov ecx, 16
	inv_crc_3:
		rcr  bx, 1
		rcl  dx,1
	loop inv_crc_3
	
	xor [eax-6], dx
	mov [Serialp1+24], dx



; :::::::::::::::::::::::::::::    GF   :::::::::::::::::::::::::::::

	push offset Serialp1
	call getLength
	
	mov ecx, eax
	mov esi, offset  Serialp1
	mov edi, offset  bufferMD5
	rep movsb

	push offset resultMD5		
	push eax
    push offset bufferMD5	
	call MD5

	lea     esi, [resultMD5]
	mov     edi, esi
	mov     ecx, 4

li_mod:   
	lodsd
	and     eax, 0FFFFFFFh
	stosd
	loop    li_mod

	push    dword ptr [resultMD5]
	push    dword ptr [resultMD5+12]
	call    GF_mul_mod_8000002D
	mov     ebx, eax
	push    dword ptr [resultMD5+4]
	push    dword ptr [resultMD5+8]
	call    GF_mul_mod_8000002D
	push    eax
	push    ebx
	call    GF_add_sub_8000002D
	push 	eax
	call	GF_inv_mod_8000002D
	mov     ecx, eax
	
	push    dword ptr [resultMD5+4]
	xor 	edx, edx
	mov     dx, word ptr [CRCBuffer+12h]
	push    edx
	call    GF_mul_mod_8000002D
	mov     ebx, eax
	push    dword ptr [resultMD5]
	xor 	edx, edx
	mov     dx, word ptr [CRCBuffer+14h]
	push    edx	
	call    GF_mul_mod_8000002D
	push    eax
	push    ebx
	call    GF_add_sub_8000002D
	push    eax
	push	ecx
	call    GF_mul_mod_8000002D
	mov     dword ptr [Serialp1+14h],eax

	push    dword ptr [resultMD5+12]
	xor 	edx, edx
	mov     dx, word ptr [CRCBuffer+12h]
	push    edx	
	call    GF_mul_mod_8000002D
	mov     ebx, eax
	push    dword ptr [resultMD5+8]
	xor 	edx, edx
	mov     dx, word ptr [CRCBuffer+14h]
	push    edx	
	call    GF_mul_mod_8000002D
	push    eax
	push    ebx
	call    GF_add_sub_8000002D
	push    eax
	push	ecx	
	call    GF_mul_mod_8000002D
	mov     dword ptr [Serialp1+10h],eax

; :::::::::::::::::::::::::::::    RC6   :::::::::::::::::::::::::::::
	push offset Serialp1
	push 1Ah
	push offset Serialp2
	call Hash
	
	push    8
	push    offset Serialp2
	call    RC6_key_expension
	
	push    offset Serialp1
	call    RC6_crypt



; :::::::::::::::::::::::::::::    Xor  :::::::::::::::::::::::::::::
	lea     esi, [Serialp1+10h]
	mov     edi, esi
	mov     dx, [Serialp1+18h]
	mov     ecx, 4
l_Xor:
	lodsw
	xor     ax, dx
	stosw
	loop    l_Xor
	
	
; :::::::::::::::::::::::::::::    Write  :::::::::::::::::::::::::::::	
	
	call CreateFileA, offset fileName, 40000000h,0,0,2,80h,0
	mov ebx, eax
	call WriteFile, ebx, offset Serialp1,22h, offset nbWritten, 0
	call CloseHandle, ebx

errorName:	
	popa
    ret
Generateur endp



GF_add_sub_8000002D proc near

arg_0		= dword	ptr  8
arg_4		= dword	ptr  0Ch

		push	ebp
		mov	ebp, esp
		push	ebx
		push	ecx
		mov	eax, [ebp+arg_0]
		mov	ebx, [ebp+arg_4]
		mov	ecx, 8000002Dh
		xor	eax, ebx
		cmp	eax, ecx
		jb	short loc_401374
		xor	eax, ecx

loc_401374:				
		pop	ecx
		pop	ebx
		leave
		retn	8
GF_add_sub_8000002D endp

GF_mul_mod_8000002D proc near		

var_4		= dword	ptr -4
arg_0		= dword	ptr  8
arg_4		= dword	ptr  0Ch

		push	ebp
		mov	ebp, esp
		pusha
		mov	eax, [ebp+arg_0]
		mov	ebx, [ebp+arg_4]
		xor	ecx, ecx
		cmp	eax, ebx
		ja	short div_loop
		xchg	eax, ebx

div_loop:				
		cmp	ebx, 0
		jz	short div0
		test	ebx, 1
		jz	short div1
		xor	ecx, eax
		cmp	ecx, 8000002Dh
		jb	short div1
		xor	ecx, 8000002Dh

div1:					
		shr	ebx, 1
		shl	eax, 1
		jnb	short loc_401345
		xor	eax, 5Ah

loc_401345:				
		cmp	eax, 8000002Dh
		jb	short div_loop
		xor	eax, 8000002Dh
		jmp	short div_loop


div0:					
		mov	[esp+20h+var_4], ecx
		popa
		leave
		retn	8
GF_mul_mod_8000002D endp

GF_inv_mod_8000002D proc near 
		push	ebp
		mov	ebp, esp
		pusha
		mov	ecx, 7FFFFFFEh
		xor	ebx, ebx
		inc	ebx
		mov	edx, [ebp+8]
		jmp	short loc_4013A3


loc_40138B:
		shr	ecx, 1
		jnb	short loc_401398
		push	edx
		push	ebx
		call	GF_mul_mod_8000002D
		mov	ebx, eax

loc_401398:
		jecxz	short loc_4013A3
		push	edx
		push	edx
		call	GF_mul_mod_8000002D
		mov	edx, eax

loc_4013A3:
		or	ecx, ecx
		jnz	short loc_40138B
		mov	[esp+1Ch], ebx
		popa
		leave
		retn	4
GF_inv_mod_8000002D endp

rev_CRC_32		proc near
		push ecx			
		mov	ecx, 32

main_loop_rev:				
		shr	eax, 1
		jnb	short mod_rev
		xor	eax, 082608EDBh
mod_rev:				
		loop	main_loop_rev
		pop ecx				
		retn
rev_CRC_32		endp

CRC_32		proc near		
		jecxz	short locret_4013E0
		not	eax

loc_4013CA:				
		xor	al, [edx]
		inc	edx
		mov	bl, 8

loc_4013CF:				
		shr	eax, 1
		jnb	short loc_4013D8
		xor	eax, 0EDB88320h

loc_4013D8:				
		dec	bl
		jnz	short loc_4013CF
		loop	loc_4013CA
		not	eax

locret_4013E0:				
		retn
CRC_32		endp

CRC_16		proc near		
		jecxz	short locret_4013C5

loc_4013B2:				
		xor	al, [edx]
		inc	edx
		mov	bl, 8

loc_4013B7:				
		shr	eax, 1
		jnb	short loc_4013BF
		xor	ax, 0A001h

loc_4013BF:				
		dec	bl
		jnz	short loc_4013B7
		loop	loc_4013B2

locret_4013C5:				
		retn
CRC_16		endp

getLength	proc near		

arg_0		= dword	ptr  8

		push	ebp
		mov	ebp, esp
		push	ebx
		mov	eax, [ebp+arg_0]
		lea	edx, [eax+3]

loc_4020DA:				
		mov	ebx, [eax]
		add	eax, 4
		lea	ecx, [ebx-1010101h]
		not	ebx
		and	ecx, ebx
		and	ecx, 80808080h
		jz	short loc_4020DA
		test	ecx, 8080h
		jnz	short loc_4020FF
		shr	ecx, 10h
		add	eax, 2

loc_4020FF:				
		shl	cl, 1
		sbb	eax, edx
		pop	ebx
		leave
		retn	4
getLength	endp

MD5		proc near		

var_10		= dword	ptr -10h
var_C		= dword	ptr -0Ch
var_8		= dword	ptr -8
var_4		= dword	ptr -4
arg_0		= dword	ptr  8
arg_4		= dword	ptr  0Ch
arg_8		= dword	ptr  10h

		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF0h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	edi
		push	esi
		mov	edi, [ebp+arg_0]
		mov	eax, [ebp+arg_4]
		inc	eax
		add	edi, eax
		mov	byte ptr [edi-1], 80h
		xor	edx, edx
		mov	ebx, 40h
		div	ebx
		neg	edx
		add	edx, 40h
		cmp	edx, 8
		jnb	short loc_40158A
		add	edx, 40h

loc_40158A:				
		mov	ecx, edx
		xor	al, al
		repe stosb
		mov	eax, [ebp+arg_4]
		inc	edx
		add	[ebp+arg_4], edx
		xor	edx, edx
		mov	ebx, 8
		mul	ebx
		mov	[edi-8], eax
		mov	[edi-4], edx
		mov	edx, [ebp+arg_4]
		mov	edi, [ebp+arg_0]
		mov	esi, [ebp+arg_8]
		mov	dword ptr [esi], 67452301h
		mov	dword ptr [esi+4], 0EFCDAB89h
		mov	dword ptr [esi+8], 98BADCFEh
		mov	dword ptr [esi+0Ch], 10325476h

loc_4015CA:				
		mov	eax, [esi]
		mov	[ebp+var_4], eax
		mov	eax, [esi+4]
		mov	[ebp+var_8], eax
		mov	eax, [esi+8]
		mov	[ebp+var_C], eax
		mov	eax, [esi+0Ch]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi]
		add	eax, 0D76AA478h
		mov	cl, 7
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+4]
		add	eax, 0E8C7B756h
		mov	cl, 0Ch
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+8]
		add	eax, 242070DBh
		mov	cl, 11h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+0Ch]
		add	eax, 0C1BDCEEEh
		mov	cl, 16h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+10h]
		add	eax, 0F57C0FAFh
		mov	cl, 7
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+14h]
		add	eax, 4787C62Ah
		mov	cl, 0Ch
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+18h]
		add	eax, 0A8304613h
		mov	cl, 11h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+1Ch]
		add	eax, 0FD469501h
		mov	cl, 16h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+20h]
		add	eax, 698098D8h
		mov	cl, 7
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+24h]
		add	eax, 8B44F7AFh
		mov	cl, 0Ch
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+28h]
		add	eax, 0FFFF5BB1h
		mov	cl, 11h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+2Ch]
		add	eax, 895CD7BEh
		mov	cl, 16h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+30h]
		add	eax, 6B901122h
		mov	cl, 7
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+34h]
		add	eax, 0FD987193h
		mov	cl, 0Ch
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+38h]
		add	eax, 0A679438Eh
		mov	cl, 11h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	ebx, eax
		not	eax
		and	eax, ecx
		or	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+3Ch]
		add	eax, 49B40821h
		mov	cl, 16h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+4]
		add	eax, 0F61E2562h
		mov	cl, 5
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+18h]
		add	eax, 0C040B340h
		mov	cl, 9
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+2Ch]
		add	eax, 265E5A51h
		mov	cl, 0Eh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi]
		add	eax, 0E9B6C7AAh
		mov	cl, 14h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+14h]
		add	eax, 0D62F105Dh
		mov	cl, 5
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+28h]
		add	eax, 2441453h
		mov	cl, 9
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+3Ch]
		add	eax, 0D8A1E681h
		mov	cl, 0Eh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+10h]
		add	eax, 0E7D3FBC8h
		mov	cl, 14h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+24h]
		add	eax, 21E1CDE6h
		mov	cl, 5
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+38h]
		add	eax, 0C33707D6h
		mov	cl, 9
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+0Ch]
		add	eax, 0F4D50D87h
		mov	cl, 0Eh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+20h]
		add	eax, 455A14EDh
		mov	cl, 14h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+34h]
		add	eax, 0A9E3E905h
		mov	cl, 5
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+8]
		add	eax, 0FCEFA3F8h
		mov	cl, 9
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+1Ch]
		add	eax, 676F02D9h
		mov	cl, 0Eh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		and	eax, ecx
		not	ecx
		and	ecx, ebx
		or	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+30h]
		add	eax, 8D2A4C8Ah
		mov	cl, 14h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+14h]
		add	eax, 0FFFA3942h
		mov	cl, 4
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+20h]
		add	eax, 8771F681h
		mov	cl, 0Bh
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+2Ch]
		add	eax, 6D9D6122h
		mov	cl, 10h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+38h]
		add	eax, 0FDE5380Ch
		mov	cl, 17h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+4]
		add	eax, 0A4BEEA44h
		mov	cl, 4
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+10h]
		add	eax, 4BDECFA9h
		mov	cl, 0Bh
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+1Ch]
		add	eax, 0F6BB4B60h
		mov	cl, 10h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+28h]
		add	eax, 0BEBFBC70h
		mov	cl, 17h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+34h]
		add	eax, 289B7EC6h
		mov	cl, 4
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi]
		add	eax, 0EAA127FAh
		mov	cl, 0Bh
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+0Ch]
		add	eax, 0D4EF3085h
		mov	cl, 10h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+18h]
		add	eax, 4881D05h
		mov	cl, 17h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_4]
		add	eax, [edi+24h]
		add	eax, 0D9D4D039h
		mov	cl, 4
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_10]
		add	eax, [edi+30h]
		add	eax, 0E6DB99E5h
		mov	cl, 0Bh
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_C]
		add	eax, [edi+3Ch]
		add	eax, 1FA27CF8h
		mov	cl, 10h
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		xor	eax, ebx
		xor	eax, ecx
		add	eax, [ebp+var_8]
		add	eax, [edi+8]
		add	eax, 0C4AC5665h
		mov	cl, 17h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi]
		add	eax, 0F4292244h
		mov	cl, 6
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+1Ch]
		add	eax, 432AFF97h
		mov	cl, 0Ah
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+38h]
		add	eax, 0AB9423A7h
		mov	cl, 0Fh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+14h]
		add	eax, 0FC93A039h
		mov	cl, 15h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+30h]
		add	eax, 655B59C3h
		mov	cl, 6
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+0Ch]
		add	eax, 8F0CCC92h
		mov	cl, 0Ah
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+28h]
		add	eax, 0FFEFF47Dh
		mov	cl, 0Fh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+4]
		add	eax, 85845DD1h
		mov	cl, 15h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+20h]
		add	eax, 6FA87E4Fh
		mov	cl, 6
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+3Ch]
		add	eax, 0FE2CE6E0h
		mov	cl, 0Ah
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+18h]
		add	eax, 0A3014314h
		mov	cl, 0Fh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+34h]
		add	eax, 4E0811A1h
		mov	cl, 15h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_C]
		mov	ecx, [ebp+var_10]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_4]
		add	eax, [edi+10h]
		add	eax, 0F7537E82h
		mov	cl, 6
		rol	eax, cl
		add	eax, [ebp+var_8]
		mov	[ebp+var_4], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_8]
		mov	ecx, [ebp+var_C]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_10]
		add	eax, [edi+2Ch]
		add	eax, 0BD3AF235h
		mov	cl, 0Ah
		rol	eax, cl
		add	eax, [ebp+var_4]
		mov	[ebp+var_10], eax
		mov	eax, [ebp+var_10]
		mov	ebx, [ebp+var_4]
		mov	ecx, [ebp+var_8]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_C]
		add	eax, [edi+8]
		add	eax, 2AD7D2BBh
		mov	cl, 0Fh
		rol	eax, cl
		add	eax, [ebp+var_10]
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_C]
		mov	ebx, [ebp+var_10]
		mov	ecx, [ebp+var_4]
		not	ecx
		or	eax, ecx
		xor	eax, ebx
		add	eax, [ebp+var_8]
		add	eax, [edi+24h]
		add	eax, 0EB86D391h
		mov	cl, 15h
		rol	eax, cl
		add	eax, [ebp+var_C]
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_4]
		add	[esi], eax
		mov	eax, [ebp+var_8]
		add	[esi+4], eax
		mov	eax, [ebp+var_C]
		add	[esi+8], eax
		mov	eax, [ebp+var_10]
		add	[esi+0Ch], eax
		add	edi, 40h
		sub	edx, 40h
		jnz	loc_4015CA
		mov	ecx, 4

loc_401F25:				
		mov	eax, [esi]
		xchg	al, ah
		rol	eax, 10h
		xchg	al, ah
		mov	[esi], eax
		add	esi, 4
		loop	loc_401F25
		pop	esi
		pop	edi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		leave
		retn	0Ch
MD5		endp

Hash		proc near	

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8
arg_8		= dword	ptr  0Ch

		pusha
		mov	ecx, [esp+20h+arg_4]
		mov	esi, [esp+20h+arg_8]
		mov	ds:buf1, ecx
		mov	ds:buf7, 1
		mov	ds:buf2, ecx
		mov	ds:buf3, esp
		mov	ds:buf6, esi
		xor	edx, edx
		xor	ebp, ebp

loc_40140D:				
		mov	esi, ds:buf6
		cmp	ds:buf2, 8
		jb	loc_4014CB
		mov	eax, [esi]
		mov	ebx, [esi+4]
		mov	ds:buf4, 20h

mainLoop:				
		mov	ecx, ebp
		mov	edi, eax
		rol	edi, cl
		mov	esp, ebx
		mov	ecx, edx
		shr	ecx, 1Bh
		rol	esp, cl
		add	edi, esp
		mov	esp, ebp
		mov	ecx, eax
		shr	ecx, 1Bh
		rol	esp, cl
		mov	ecx, ebx
		mov	esi, edx
		rol	esi, cl
		add	esi, esp
		xor	edi, esi
		mov	eax, edi
		add	eax, 4B455947h
		xchg	eax, ebx
		xchg	ebx, edx
		xchg	edx, ebp
		mov	ecx, edx
		mov	edi, eax
		rol	edi, cl
		mov	esp, ebx
		mov	ecx, ebp
		shr	ecx, 1Bh
		rol	esp, cl
		xor	edi, esp
		mov	ecx, eax
		mov	esp, edx
		rol	esp, cl
		add	edi, esp
		mov	esp, ebp
		mov	ecx, ebx
		shr	ecx, 1Bh
		rol	esp, cl
		add	edi, esp
		mov	eax, edi
		imul	eax, 454E4D45h
		xchg	eax, ebx
		xchg	ebx, edx
		xchg	edx, ebp
		dec	ds:buf4
		jnz	short mainLoop
		mov	ecx, ebp
		mov	esp, eax
		rol	esp, cl
		mov	ecx, edx
		shr	ecx, 1Bh
		mov	esi, ebx
		rol	esi, cl
		add	esp, esi
		mov	ecx, eax
		shr	ecx, 1Bh
		rol	edx, cl
		mov	ecx, ebx
		rol	ebp, cl
		xor	ebp, edx
		mov	edx, esp
		sub	ds:buf2, 8
		add	ds:buf6, 8
		jmp	loc_40140D


loc_4014CB:				
		cmp	ds:buf7, 0
		jz	short loc_401539
		mov	ecx, ds:buf2
		and	ds:buf7, 0
		mov	ds:buf2, 8
		mov	eax, ecx
		mov	edi, offset buf5
		test	eax, eax
		jz	short loc_401503

loc_4014F6:				
		mov	bl, [ecx+esi-1]
		mov	[ecx+edi-1], bl
		dec	ecx
		jnz	short loc_4014F6
		add	edi, eax

loc_401503:				
		mov	ecx, ds:buf1
		mov	[edi], ecx
		mov	ecx, eax
		add	edi, 4
		sub	ecx, 4
		neg	ecx
		jz	short loc_40152A
		jns	short loc_401523
		add	ds:buf2, 8
		add	ecx, 8

loc_401523:				
		dec	ecx
		mov	byte ptr [ecx+edi], 0FFh
		jnz	short loc_401523

loc_40152A:				
		mov	ds:buf6, offset	buf5
		jmp	loc_40140D


loc_401539:				
		mov	esp, ds:buf3
		mov	eax, [esp+20h+arg_0]
		mov	[eax], edx
		mov	[eax+4], ebp
		mov	edi, offset buf1
		xor	eax, eax
		mov	ecx, 0Ah
		cld
		repe stosd
		popa
		retn	0Ch
Hash		endp	


RC6_key_expension proc near		

var_10		= dword	ptr -10h
var_C		= dword	ptr -0Ch
var_8		= dword	ptr -8
var_4		= dword	ptr -4
arg_0		= dword	ptr  8
arg_4		= dword	ptr  0Ch

	push    ebp
	mov     ebp, esp
	add     esp, 0FFFFFFF0h
	mov     edi, offset RC6_S
	mov     ecx, 0A6F04072h
	xor     ecx, 11111111h  ; A6F04072
	mov     [edi], ecx
	xor     ecx, ecx
	inc     ecx
	mov     edx, 38C739CBh
	xor     edx, 0A6F04072h ; 9E3779B9


ini_RC6_S:				
		mov	eax, [edi+ecx*4-4]
		add	eax, edx
		mov	[edi+ecx*4], eax
		inc	ecx
		cmp	ecx, 2Ch
		jb	short ini_RC6_S

		
		xor	ecx, ecx
		mov	esi, [ebp+arg_0]
		mov	edx, [ebp+arg_4]
		shr	edx, 5

loc_401F7F:	
		mov	eax, [esi+ecx*4]
		mov	[edi+ecx*4], eax
		inc	ecx
		cmp	ecx, edx
		jb	short loc_401F7F
		
		mov	esi, [offset RC6_S + 0B4h] 
		dec	edx
		xor	ecx, ecx
		mov	[ebp+var_4], ecx
		mov	[ebp+var_8], ecx
		mov	[ebp+var_C], ecx
		mov	[ebp+var_10], ecx

bigMix:					
		push	ecx
		mov	ebx, [ebp+var_C]
		mov	eax, [edi+ebx*4]
		add	eax, [ebp+var_4]
		add	eax, [ebp+var_8]
		rol	eax, 3
		add	[ebp+var_8], eax
		mov	[ebp+var_4], eax
		mov	ebx, [ebp+var_10]
		mov	eax, [esi+ebx*4]
		add	eax, [ebp+var_8]
		mov	ecx, [ebp+var_8]
		rol	eax, cl
		mov	[ebp+var_8], eax
		mov	eax, [ebp+var_4]
		mov	ebx, [ebp+var_C]
		mov	[edi+ebx*4], eax
		mov	eax, [ebp+var_8]
		mov	ebx, [ebp+var_10]
		mov	[esi+ebx*4], eax
		mov	eax, [ebp+var_C]
		inc	eax
		cmp	eax, 2Bh
		jnz	short loc_401FE2
		xor	eax, eax

loc_401FE2:			
		mov	[ebp+var_C], eax
		mov	eax, [ebp+var_10]
		inc	eax
		cmp	eax, edx
		jnz	short loc_401FEF
		xor	eax, eax

loc_401FEF:				
		mov	[ebp+var_10], eax
		pop	ecx
		inc	ecx
		cmp	ecx, 84h
		jb	short bigMix
		mov	eax, edi
		leave
		retn	4
RC6_key_expension endp

RC6_crypt proc
	pusha
	mov ebp, offset RC6_S
	mov edi, [esp+24h]
	mov eax, [edi]
	mov ebx, [edi+4]
	mov ecx, [edi+8]
	mov esi, ecx
	mov edx, [edi+12]
	
	
	;B=B+S[0]	
	add ebx, [ebp]
	add ebp, 4
	
	;D=D+S[1]	
	add edx, [ebp]
	add ebp, 4	
	mov ecx, 20

exp_RC6_S:
	push ecx
	mov ecx, esi
	
	;t=(B*(2B+1)) <<< 5
	lea esi, [2*ebx+1]
	imul esi, ebx
	rol esi, 5

	;u=(D*(2D+1)) <<< 5
	lea edi, [2*edx+1]
	imul edi, edx
	rol edi, 5
	
	; A = ((A xor t) <<< u) + S[2i]
	xor eax, esi
	xchg edi, ecx
	rol  eax, cl
	xchg edi, ecx
	add eax, [ebp]
	add ebp, 4

	; C = ((C xor u) <<< t) + S[2i+1]
	xchg eax, ecx
	xor eax, edi
	xchg esi, ecx
	rol  eax, cl
	xchg esi, ecx
	add eax, [ebp]
	add ebp, 4	
	xchg eax, ecx 	

    ; ( A, B, C, D) = ( B, C, D, A)
	xchg eax, ebx
	xchg ebx, ecx
	xchg ecx, edx
	
	mov esi, ecx
	pop ecx
	loop exp_RC6_S

	;A=A+S[42]
	add eax, [ebp]
	add ebp, 4
	
	;C=C+S[43]
	mov ecx, esi	
	add ecx, [ebp]
	
	mov edi, [esp+24h]
	mov [edi], eax
	mov [edi+4], ebx
	mov [edi+8], ecx
	mov [edi+12], edx	
	popa
	retn 8
RC6_crypt endp

end Corps
ends
